import java.io.FileNotFoundException;
import java.io.IOException;

import org.jdom.JDOMException;

import com.j2docx.operations.DOCXHandler;
import com.j2docx.spray.BookmarkSprayer;

import com.j2docx.util.DOCXUtil;
import com.j2docx.DocxHandlerException;

/**
 * @author j2docx
 * Demo for spraying custom xml in the target file.
 */
public class CustomXMLSprayTarget {
	
	public static void main(String[] args) {
		
		try{
			//for extraction
			String docPath= "C:/demo/custom xml/write_custom_xml_target.docx";
			String targetDirPath="C:/demo/custom xml";
		
			//for archiving
			String extractedPath= "C:/demo/custom xml/write_custom_xml_target";
			
			//Target xml file to be written.
			String xmlFilePath= "C:/demo/custom xml/write_custom_xml_target/word/header1.xml";
			
			//The system generated content control id
			String contentControlId = "-644730585";
		
			DOCXHandler docxHandler= new DOCXHandler();
			BookmarkSprayer BMSprayer= new BookmarkSprayer();
		
			//Extracting docx to the targeted directory path
			docxHandler.doExtract(docPath, targetDirPath);

			//getting custom xml contents by doing the XSLT transformation
		    String s= DOCXUtil.getTransformedContentAsString("C:/demo/custom xml/xml-xsl/sampleXsl.xsl",
		        		"C:/demo/custom xml/xml-xsl/sampleXml.xml"
		        		);
			//Writing xustom xml in the target xml file.
			BMSprayer.sprayCustomXMLTargetFile(xmlFilePath, contentControlId, s);
						
			//Archiving back to get docx file
			docxHandler.doZip(extractedPath, docPath);
		}
		catch(DocxHandlerException dhe){
			dhe.printStackTrace();
		}
		catch(FileNotFoundException fnf){
			fnf.printStackTrace();
		}
		catch(IOException ioe){
			ioe.printStackTrace();
		}
		catch(JDOMException jdome){
			jdome.printStackTrace();
		}
	}
}