import java.io.FileNotFoundException;
import java.io.IOException;

import org.jdom.JDOMException;

import com.j2docx.operations.DOCXHandler;
import com.j2docx.spray.BookmarkSprayer;

import com.j2docx.util.DOCXUtil;
import com.j2docx.DocxHandlerException;

/**
 * @author j2docx
 * Demo for spraying custom xml
 */
public class CustomXMLSpray {
	
	public static void main(String[] args) {
		
		try{
			//for extraction
			String docPath= "C:/demo/custom xml/write_custom_xml.docx";
			String targetDirPath="C:/demo/custom xml";
		
			//for archiving
			String extractedPath= "C:/demo/custom xml/write_custom_xml";
			
			//The system generated content control id
			String contentControlId = "-4946017";
		
			DOCXHandler docxHandler= new DOCXHandler();
			BookmarkSprayer BMSprayer= new BookmarkSprayer();
		
			//Extracting docx to the targeted directory path
			docxHandler.doExtract(docPath, targetDirPath);

			//getting custom xml contents by doing the XSLT transformation
		    String s= DOCXUtil.getTransformedContentAsString("C:/demo/custom xml/xml-xsl/sampleXsl.xsl",
		        		"C:/demo/custom xml/xml-xsl/sampleXml.xml"
		        		);
			
			BMSprayer.sprayCustomXML(extractedPath, contentControlId, s);
						
			//Archiving back to get docx file
			docxHandler.doZip(extractedPath, docPath);
		}
		catch(DocxHandlerException dhe){
			dhe.printStackTrace();
		}
		catch(FileNotFoundException fnf){
			fnf.printStackTrace();
		}
		catch(IOException ioe){
			ioe.printStackTrace();
		}
		catch(JDOMException jdome){
			jdome.printStackTrace();
		}
	}
}