import java.io.FileNotFoundException;
import java.io.IOException;

import org.jdom.JDOMException;

import com.j2docx.operations.DOCXHandler;
import com.j2docx.spray.BookmarkSprayer;

import com.j2docx.DocxHandlerException;

/**
 * @author j2docx
 * Demo for spraying hyperlink in the target file
 */
public class HyperlinkSprayTarget {
	
	public static void main(String[] args) {
		
		try{
			//for extraction
			String docPath= "C:/demo/hyperlink/hyperlink_target.docx";
			String targetDirPath="C:/demo/hyperlink";
		
			//for archiving
			String extractedPath= "C:/demo/hyperlink/hyperlink_target";
		
			//Bookmark name
			String bookmarkName="hypt";
			
			//The target xml file to be written.
			String xmlFilePath= "C:/demo/hyperlink/hyperlink_target/word/document.xml";
			
			String targetName = "www.google.com";
			String targetValue = "www.google.com";
		
			DOCXHandler docxHandler= new DOCXHandler();
			BookmarkSprayer bmSprayer= new BookmarkSprayer();
		
			//Extracting docx to the targeted directory path
			docxHandler.doExtract(docPath, targetDirPath);

			//Writing hyperlink in the target file
			bmSprayer.sprayHyperLinkTargetFile(extractedPath, xmlFilePath, bookmarkName, targetName, targetValue);
			
			//Archiving back to get docx file
			docxHandler.doZip(extractedPath, docPath);
		}
		catch(DocxHandlerException dhe){
			dhe.printStackTrace();
		}
		catch(FileNotFoundException fnf){
			fnf.printStackTrace();
		}
		catch(IOException ioe){
			ioe.printStackTrace();
		}
		catch(JDOMException jdome){
			jdome.printStackTrace();
		}
	}
}