import java.io.FileNotFoundException;
import java.io.IOException;

import org.jdom.JDOMException;

import com.j2docx.operations.DOCXHandler;
import com.j2docx.spray.BookmarkSprayer;
import com.j2docx.DocxHandlerException;

/**
 * @author j2docx
 * Demo for spraying image in the target file
 */
public class ImageSprayTarget {
	
	public static void main(String[] args) {
		
		try{
			//for extraction
			String docPath= "C:/demo/image/image_target.docx";
			String targetDirPath="C:/demo/image";
		
			//for archiving
			String extractedPath= "C:/demo/image/image_target";
		
			//Bookmark name
			String bookmarkName="imgt";
			
			//The target xml file to be written.
			String xmlFilePath= "C:/demo/image/image_target/word/document.xml";
		
			DOCXHandler docxHandler= new DOCXHandler();
			BookmarkSprayer bmSprayer= new BookmarkSprayer();
		
			//Extracting docx to the targeted directory path.
			docxHandler.doExtract(docPath, targetDirPath);

			//Writing image in the target file.
			bmSprayer.sprayImageTargetFile(extractedPath, xmlFilePath, bookmarkName, 70, 170, "C:/demo/image/sample_image.png");
			
			//Archiving back to get docx file.
			docxHandler.doZip(extractedPath, docPath);
		}
		catch(DocxHandlerException dhe){
			dhe.printStackTrace();
		}
		catch(FileNotFoundException fnf){
			fnf.printStackTrace();
		}
		catch(IOException ioe){
			ioe.printStackTrace();
		}
		catch(JDOMException jdome){
			jdome.printStackTrace();
		}
	}
}