import java.io.FileNotFoundException;
import java.io.IOException;

import org.jdom.JDOMException;

import com.j2docx.operations.DOCXHandler;
import com.j2docx.spray.BookmarkSprayer;

import com.j2docx.DocxHandlerException;

/**
 * @author j2docx
 * Demo for spraying text in the target file.
 */
public class TextSprayTarget {
	
	public static void main(String[] args) {
		
		try{
			//for extraction
			String docPath= "C:/demo/text/text_target.docx";
			String targetDirPath="C:/demo/text";
		
			//for archiving
			String extractedPath= "C:/demo/text/text_target";
			//Target xml file to be written.
			String xmlFilePath= "C:/demo/text/text_target/word/document.xml";
		
			//Bookmark name
			String bookmarkName="bmt";
		    //Text to be sprayed
			String value="Hello world! Text has been written in the target!";
			
			String style = "font-family:verdana;font-size:28;font-weight:bold;font-color:#FF0000;italic:false";
		
			DOCXHandler docxHandler= new DOCXHandler();
			
			BookmarkSprayer bmSprayer= new BookmarkSprayer();
		
			//(Unzip)Extracting docx to the targeted directory path
			docxHandler.doExtract(docPath, targetDirPath);
			
			//Writing text on the pre-defined bookmark in the target file.
			bmSprayer.sprayTextTargetFile(xmlFilePath, bookmarkName, value, style);
			
			//(Zip)Archiving to get docx file
			docxHandler.doZip(extractedPath, docPath);
		}
		catch(DocxHandlerException dhe){
			dhe.printStackTrace();
		}
		catch(FileNotFoundException fnf){
			fnf.printStackTrace();
		}
		catch(IOException ioe){
			ioe.printStackTrace();
		}
		catch(JDOMException jdome){
			jdome.printStackTrace();
		}
	}
}
