import java.io.FileNotFoundException;
import java.io.IOException;

import org.jdom.JDOMException;

import com.j2docx.operations.DOCXHandler;
import com.j2docx.spray.BookmarkSprayer;

import com.j2docx.DocxHandlerException;

/**
 * @author j2docx
 * Demo for spraying text with style definitions
 */
public class TextSprayWithStyle {
	
	public static void main(String[] args) {
		
		try{
			//for extraction
			String docPath= "C:/demo/text/text_with_style.docx";
			String targetDirPath="C:/demo/text";
		
			//for archiving
			String extractedPath= "C:/demo/text/text_with_style";
		
			//Bookmark name
			String bookmarkName="bm1";
		    //Text to be sprayed
			String value="Hello world! Text has been written with the style definitions!";
			
			String style = "font-family:verdana;font-size:28;font-weight:bold;font-color:#008000;italic:false;uline:single";
		
			DOCXHandler docxHandler= new DOCXHandler();
			
			BookmarkSprayer bmSprayer= new BookmarkSprayer();
		
			//(Unzip)Extracting docx to the targeted directory path
			docxHandler.doExtract(docPath, targetDirPath);
			
			//Writing text on the pre-defined bookmark 
			bmSprayer.sprayText(extractedPath, bookmarkName, value, style);
			
			//(Zip)Archiving to get docx file
			docxHandler.doZip(extractedPath, docPath);
		}
		catch(DocxHandlerException dhe){
			dhe.printStackTrace();
		}
		catch(FileNotFoundException fnf){
			fnf.printStackTrace();
		}
		catch(IOException ioe){
			ioe.printStackTrace();
		}
		catch(JDOMException jdome){
			jdome.printStackTrace();
		}
	}
}
